import type { Logger } from '@message-queue-toolkit/core';
import type { Connection } from 'amqplib';
import type { AmqpConfig } from './amqpConnectionResolver';
export type ConnectionReceiver = {
    receiveNewConnection(connection: Connection): Promise<void>;
    close(): Promise<void>;
};
export declare class AmqpConnectionManager {
    private readonly config;
    private readonly logger;
    private readonly connectionReceivers;
    private connection?;
    reconnectsActive: boolean;
    isReconnecting: boolean;
    constructor(config: AmqpConfig, logger: Logger);
    private createConnection;
    getConnectionSync(): Connection | undefined;
    getConnection(): Promise<Connection>;
    reconnect(): Promise<void>;
    init(): Promise<void>;
    close(): Promise<void>;
    subscribeConnectionReceiver(connectionReceiver: ConnectionReceiver): void;
}
